/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  25 Mar 2007 4:41:07 pm

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

#ifndef __JUCER_HEADER_WINDOW_WINDOW_CB1CF48B__
#define __JUCER_HEADER_WINDOW_WINDOW_CB1CF48B__

//[Headers]     -- You can add your own extra header files here --
#include "juce.h"

#include "DrawingPanel.h"
#include "FileLoader.h"
//[/Headers]



//==============================================================================
/**
                                                                    //[Comments]
    An auto-generated component, created by the Jucer.

    Describe your class and how it works here!
                                                                    //[/Comments]
*/
class Window  : public Component,
                public MenuBarModel,
                public TextEditorListener,
                public ChangeListener,
                public ButtonListener
{
public:
    //==============================================================================
    Window ();
    ~Window();

    //==============================================================================
    //[UserMethods]     -- You can add your own custom methods in this section.

	const StringArray getMenuBarNames(MenuBarComponent* menuBar);
	const PopupMenu getMenuForIndex(MenuBarComponent* menuBar,
                                    int topLevelMenuIndex,
                                    const String& menuName);
	void menuItemSelected(MenuBarComponent* menuBar,
                          int menuItemID,
                          int topLevelMenuIndex);
	void textEditorTextChanged(TextEditor& editor);
	void textEditorReturnKeyPressed(TextEditor& editor) {};
	void textEditorEscapeKeyPressed(TextEditor& editor) {};
	void textEditorFocusLost(TextEditor& editor) {};
	void changeListenerCallback(void *object);

	///	Updates the colours.
	void setPolygonColour(int index, const Colour& colour);
	///	Returns the colours.
	Colour getPolygonColour(int index) const;

	///	Set the indexed polygon list.
	void setPolygonList(int index, const std::list<Polygon>& polysList);
	///	Returns the indexed polygon list.
	const std::list<Polygon>& getPolygonList(int index) const;

	///	Sets the length.
	void setLength(float val);
	///	Returns the length.
	float getLength() const;

    //[/UserMethods]

    void paint (Graphics& g);
    void resized();
    void buttonClicked (Button* buttonThatWasClicked);


    //==============================================================================
    juce_UseDebuggingNewOperator

private:
    //[UserVariables]   -- You can add your own custom variables in this section.

	///	Enum used to enumerate the various menu IDs.
	enum
	{
		FileNew = 1,
		FileOpen,
		FileSave,
		FileSaveAs,
		FileQuit,
		ViewHeilan,
		ViewOptions,
		HelpAbout
	};

	///	Used to load and save .x3d files.
	FileLoader *fileLoader;

	///	Last selected polygons in the store dialog.
	bool lastSelectedPolys[4];

	///	The current time, displayed in currentFrame.
	float currentTime;
	///	The current length in seconds.
	float currentLength;

    //[/UserVariables]

    //==============================================================================
    DrawingPanel* drawingPanel;
    TextButton* prevFrame;
    TextEditor* currentFrame;
    TextButton* nextFrame;
    TextButton* store;
    TextButton* play;
    Label* lengthLabel;
    TextEditor* length;
    TextButton* colour1;
    TextButton* colour2;
    TextButton* colour3;
    TextButton* colour4;
    Label* coloursLabel;

    //==============================================================================
    // (prevent copy constructor and operator= being generated..)
    Window (const Window&);
    const Window& operator= (const Window&);
};


#endif   // __JUCER_HEADER_WINDOW_WINDOW_CB1CF48B__
